% PWM - PONT COMPLERT DE DOS NIVELLS
% inici
clear;

% senyal triangle 
m = 0.9; % maxim voltatge
n = 20; % numero de punts dins una rampa
fg = 0; % numero de figures 
trn = [(1:-1/n:-1)]; % vector de punts amb increments negatius de -0.05
trp = [(-1:+1/n:1)]; % vector de punts amb increments positius de +0.05 
tr0 =  [trn,trp]; % senyal triangle
tr = tr0; % senyal triangle

% duplicaci d'un senyal triangle
tr = [tr, tr, tr]; % 3 PWM per cicle
tr =[tr, tr, tr];% 9 PWM per cicle
tr =[tr, tr, tr]; % 27 PWM per cicle

% senyal sinusoidal
f = (1:(length(tr)))/length(tr); % Determina la frequencia de la ona
wt = 2*pi*f; % velocitat angular 
u_u0 = m*cos (wt); % generaci de la ona sinusoidal u
u_v0 = m*cos (wt-pi*2/3); % generaci de la ona sinusoidal v
u_w0 = m*cos (wt+pi*2/3); % generaci de la ona sinusoidal w

% senyal PWM i fase dels voltatges
% quan el sinus es mes gran que el triangle dona u
u_u1 = (u_u0>tr)-0.5;
u_v1 = (u_v0>tr)-0.5;
u_w1 = (u_w0>tr)-0.5;

% intensitats
i_u0 = cumsum(u_u1); i_u = i_u0 - mean(i_u0);
i_v0 = cumsum(u_v1); i_v = i_v0 - mean(i_v0);
i_w0 = cumsum(u_w1); i_w = i_w0 - mean(i_w0);

%---------dibuixar triangle, referencia i senyals PWM 
fg =fg+1;
figure(fg); clf;
subplot(4,1,1);
plot (wt, tr, 'k'); hold on;
plot (wt, u_u0, 'r');
plot (wt, u_v0, 'g');
plot (wt, u_w0, 'b');
axis ([0, wt(end), -1.1, 1.1]);
ylabel ('duty cycle');
title('Triangle i voltatge de referencia');

% Senyals PWM i voltatges
subplot(4,1,2);
plot(wt, u_u1, 'r'); axis ([0, wt(end), -1.1, 1.1]);
ylabel('u');
subplot(4,1,3);
plot(wt, u_v1, 'g'); axis ([0, wt(end), -1.1, 1.1]); 
ylabel('v');
subplot(4,1,4);
plot(wt, u_w1, 'b'); axis ([0, wt(end), -1.1, 1.1]); 
ylabel('w');

% corrents
fg = fg+1;
figure (fg); clf;
hold on
title('Corrents de fase');
plot(wt, i_u, 'r'); plot(wt, i_v, 'g'); plot(wt, i_w, 'b');
grid on


