% PWM - PONT COMPLERT DE TRES NIVELLS
% inici
clear;


% senyal triangle 
m = 0.9; % maxim voltatge
n = 20; % numero de punts dins una rampa
fg = 0; % numero de figures 
trn = [(1:-1/n:-1)]; % vector de punts amb increments negatius de -0.05
trp = [(-1:+1/n:1)]; % vector de punts amb increments positius de +0.05 
tr0 =  [trn,trp]; % senyal triangle
tr = tr0; % senyal triangle

% duplicaci d'un senyal triangle
tr = [tr, tr, tr]; % 3 PWM per cicle
tr =[tr, tr, tr];% 9 PWM per cicle
tr =[tr, tr, tr]; % 27 PWM per cicle

% senyal sinoidal
f = (1:(length(tr)))/length(tr); % Determina la frequencia de la ona
wt = 2*pi*f; % velocitat angular 
u_u0 = m*cos (wt); % generaci de la ona sinusoidal u
u_v0 = m*cos (wt-pi*2/3); % generaci de la ona sinusoidal v
u_w0 = m*cos (wt+pi*2/3); % generaci de la ona sinusoidal w


% senyal PWM i fase dels voltatges
% quan el sinus es mes gran que el triangle dona u
% generem el vector i, format per a nombre de valors de PWM
for i=1:length(tr)
u_u1(i)=0;
u_v1(i)=0;
u_w1(i)=0;
end
  
% Determinar part positiva i part negativa de la generaci de PWM 
for i=1:length(tr)
    valor = u_u0(i);    
    if (u_u0(i) > 0) & (u_u0(i)>tr(i)) u_u1(i)=1;
    elseif (u_u0(i) < 0) & (u_u0(i)>tr(i)) u_u1(i)=-1;
    end 
  end

 
for i=1:length(tr)
    valor = u_v0(i);    
    if (u_v0(i) > 0) & (u_v0(i)>tr(i)) u_v1(i)=1;
    elseif (u_v0(i) < 0) & (u_v0(i)>tr(i)) u_v1(i)=-1;
    end
end
  
for i=1:length(tr)
    valor = u_w0(i);    
    if (u_w0(i) > 0) & (u_w0(i)>tr(i)) u_w1(i)=1;
    elseif (u_w0(i) < 0) & (u_w0(i)>tr(i)) u_w1(i)=-1;
    end 
end

% Determinem la forma d'ona dels corrents de fase
for i=2:length(tr)
    i_u0(1)=0;
    if (u_u0(i) > 0 & u_u1(i) == 0)  i_u0(i)=i_u0(i-1)-1; 
    elseif (u_u0(i)>0)  i_u0(i)= i_u0(i-1)+1; 
    end
    
    if (u_u0(i) < 0 & u_u1(i) == 0)  i_u0(i)=i_u0(i-1)-1; 
    elseif (u_u0(i)<0)  i_u0(i)= i_u0(i-1)+1; 
    end
end

i_u=i_u0-mean(i_u0);

for i=2:length(tr)
    i_v0(1)=0;   
    if (u_v0(i) > 0 & u_v1(i) == 0) i_v0(i)=i_v0(i-1)-1; 
    elseif (u_v0(i)>0) i_v0(i)=i_v0(i-1)+1; 
    end
    
    if (u_v0(i) < 0 & u_v1(i) == 0) i_v0(i)=i_v0(i-1)-1; 
    elseif (u_v0(i)<0) i_v0(i)=i_v0(i-1)+1; 
    end
end

i_v=i_v0-mean(i_v0);

for i=2:length(tr)
    i_w0(1)=0;   
    if (u_w0(i) > 0 & u_w1(i) == 0) i_w0(i)=i_w0(i-1)-1;
    elseif (u_w0(i)>0)  i_w0(i)= i_w0(i-1)+1;
    end
    
    if (u_w0(i) <0   & u_w1(i) == 0) i_w0(i)=i_w0(i-1)-1;
    elseif (u_w0(i)<0) i_w0(i)= i_w0(i-1)+1;
    end
end

i_w=i_w0-mean(i_w0);


%---------dibuixar triangle, referencia i senyals PWM 
fg =fg+1;
figure(fg); clf;
subplot(4,1,1);
plot (wt, tr, 'k'); hold on;
plot (wt, u_u0, 'r');
plot (wt, u_v0, 'g');
plot (wt, u_w0, 'b');
axis ([0, wt(end), -1.1, 1.1]);
ylabel ('duty cycle');
title('Triangle i voltatge de referencia');

% Senyals PWM i voltatges
subplot(4,1,2);
plot(wt, u_u1, 'r'); axis ([0, wt(end), -1.1, 1.1]);
ylabel('u');
subplot(4,1,3);
plot(wt, u_v1, 'g'); axis ([0, wt(end), -1.1, 1.1]); 
ylabel('v');
subplot(4,1,4);
plot(wt, u_w1, 'b'); axis ([0, wt(end), -1.1, 1.1]); 
ylabel('w');

% corrents

fg = fg+1;
figure (fg);
clf;
hold on
title('Corrents de fase');
plot(wt, i_u, 'r'); plot(wt, i_v, 'g'); plot(wt, i_w, 'b');
grid on
