
-------------------------DIVISOR DE FREQÜÈNCIES----------------------------

library ieee;
	use ieee.std_logic_1164.all;

-- Declaració d'entrades i sortides del bloc	
entity DivisorFrequencia is
	port( clk50M : in std_logic;
			entrada : in integer range 0 to 50:=0;
			Fre_50Hz : out std_logic;
			Fre_5kHz : out std_logic;
			Fre_9kHz : out std_logic);
end DivisorFrequencia;

-- Declaració de l'arquitectura interna del divisor de freqüències
architecture arch of DivisorFrequencia is

	-- determinem el rang dels comptadors i els inicialitzem a zero	
	signal valor1,valor2 : integer range 0 to 50000000:=0;
	signal comptador50Hz : integer range 0 to 50000000:=0;
	signal valor3,valor4 : integer range 0 to 50000000:=0;
	signal comptador5kHz : integer range 0 to 50000000:=0;
	signal valor5,valor6: integer range 0 to 50000000:=0;
	signal comptador9kHz : integer range 0 to 50000000:=0;
	signal valor50Hz,valor5kHz,valor9kHz : std_logic;
	
begin
	process (clk50M,entrada)
	begin
	
	if (entrada > 0) then
		-- passem de una frequencia de 50MHz a una de 50Hz
		valor1 <= 50000000/entrada;
		valor2 <= valor1/2;
		if (rising_edge (clk50M)) then comptador50Hz <= comptador50Hz + 1;
			if (comptador50Hz = valor1) then comptador50Hz <= 0;
			end if;
		end if;
		if (clk50M' event and clk50M = '0') then
			if (comptador50Hz < valor2) then valor50Hz <= '1';
			else valor50Hz <='0';
			end if;
		end if;
		
		-- passem de una frequencia de 50MHz a una de 5kHz
		valor3 <= 50000000/(entrada*60);
		valor4 <= valor3/2;
		if (rising_edge (clk50M)) then comptador5kHz <= comptador5kHz + 1;
			if (comptador5kHz = valor3) then comptador5kHz <= 0;
			end if;
		end if;
		if (clk50M' event and clk50M = '0') then
			if (comptador5kHz < valor4) then valor5kHz <= '1';
			else valor5kHz <='0';
			end if;
		end if;
		
		-- passem de una frequencia de 50MHz a una de 9kHz
		valor5 <= 50000000/(entrada*360);
		valor6 <= valor5/2;
		if (rising_edge (clk50M)) then comptador9kHz <= comptador9kHz + 1;
			if (comptador9kHz = valor5) then comptador9kHz <= 0;
			end if;
		end if;
		if (clk50M' event and clk50M = '0') then
			if (comptador9kHz < valor6) then valor9kHz <= '1';
			else valor9kHz <='0';
			end if;
		end if;
	end if;

	Fre_50Hz <= valor50Hz;
	Fre_5kHz <= valor5kHz;
	Fre_9kHz <= valor9kHz;
	
	end process;
end architecture;
