

--------------------------COMPTADOR UP & DOWN------------------------------

 --Aquest bloc compta de 0 fins a 50, per així poder determinar la 
 --frequencia intruduida per l'usuari.
library ieee;
	use ieee.std_logic_1164.all;
	use ieee.std_logic_unsigned.all;

--Es declara la entitat del UP & DOWN, formada per 2 bits d'entrada i 
--un bus de sortida.	
entity UpDown is
	port (Up       : in bit;
			Down     : in bit;
			sortida1 : out integer range 0 to 50:=0);	
end entity;

--Es declara l'arquitectura interna del UP & DOWN
architecture arch1 of UpDown is
--Declarem els senyals interns que hi ha dins 
--l'arquitectura, de quin tipus son i quin rang tenen
	signal comptador1  : integer range 0 to 200:=0;
	signal comptador2 : integer range 0 to 200:=0;
	signal valor : integer range 0 to 50:=0;
	signal valorMax : natural := 50;
	signal valorMin : natural := 0;
	
begin
	process (Up,Down) 
	begin
	--Si llegim un canvi en el bit d'entrada UP i 
	--aquest canvi és un '1' lògic, aleshores
	--incrementem el valor del comptador
		
		if (Up' event and Up = '1') then	
			comptador1 <= valor + 1;
		end if;
			
		if (Down' event and Down = '1') then
			comptador2 <= comptador2 + 1;
		end if;
		
		--Determinem el valor final amb la resta dels dos comptadors
		valor <= comptador1 - comptador2;

		--Acotem el valor màxim i el valor mínim del bus de sortida
		if (valor < valorMin) then
			valor <= valorMin;
			elsif (valor > valorMax)then
			valor <= valorMax;
		end if;
		
		sortida1 <= valor;
		
	end process;
end architecture;